Auto hide/show expand collapse icon in EJ2 JavaScript TreeView control

28 Jan 20258 minutes to read

You can display the expand icon by hovering the mouse over the TreeView, and hide the expand icon by moving the mouse away. Refer to the following code sample to automatically hide/show the expand/collapse icon using the mouse.

/**
* TreeView Auto hide/show expand/collapse icons
*/

// Hierarchical data source for TreeView control
var countries = [
  { id: 1, name: 'India', hasChild: true },
  { id: 2, pid: 1, name: 'Assam' },
  { id: 3, pid: 1, name: 'Bihar' },
  { id: 4, pid: 1, name: 'Tamil Nadu' },
  { id: 6, pid: 1, name: 'Punjab' },
  { id: 7, name: 'Brazil', hasChild: true },
  { id: 8, pid: 7, name: 'ParanĂ¡' },
  { id: 9, pid: 7, name: 'CearĂ¡' },
  { id: 10, pid: 7, name: 'Acre' },
  { id: 11, name: 'France', hasChild: true },
  { id: 12, pid: 11, name: 'Pays de la Loire' },
  { id: 13, pid: 11, name: 'Aquitaine' },
  { id: 14, pid: 11, name: 'Brittany' },
  { id: 15, pid: 11, name: 'Lorraine' },
  { id: 16, name: 'Australia', hasChild: true },
  { id: 17, pid: 16, name: 'New South Wales' },
  { id: 18, pid: 16, name: 'Victoria' },
  { id: 19, pid: 16, name: 'South Australia' },
  { id: 20, pid: 16, name: 'Western Australia' },
  { id: 21, name: 'China', hasChild: true },
  { id: 22, pid: 21, name: 'Guangzhou' },
  { id: 23, pid: 21, name: 'Shanghai' },
  { id: 24, pid: 21, name: 'Beijing' },
  { id: 25, pid: 21, name: 'Shantou' }

];

// Renders TreeView
var tree1 = new ej.navigations.TreeView({
  fields: { dataSource: countries, id: 'id', text: 'name', parentID: 'pid', hasChildren: 'hasChild' },
  created: onCreate
});
tree1.appendTo('#tree');

function onCreate() {
  var treeElement = document.getElementById("tree");
  var collapse = treeElement.querySelectorAll('.e-icons.e-icon-collapsible');
  var expand = treeElement.querySelectorAll('.e-icons.e-icon-expandable');
  hideIcon(expand, collapse);
  treeElement.addEventListener('mouseenter', function (e) {
    showIcon(expand, collapse);
  })
  treeElement.addEventListener('mouseleave', function (e) {
    hideIcon(expand, collapse);
  })
}

// hides expand/collapse icon on hovering the mouse
function hideIcon(expand, collapse) {
  for (var i = 0; i < collapse.length; i++) {
    collapse[i].setAttribute('style', 'visibility: hidden');
  }
  for (var j = 0; j < expand.length; j++) {
    expand[j].setAttribute('style', 'visibility: hidden');
  }
}

// shows expand/collapse icon while leaving the mouse
function showIcon(expand, collapse) {
  for (var i = 0; i < collapse.length; i++) {
    collapse[i].setAttribute('style', "visibility: visible");
  }
  for (var j = 0; j < expand.length; j++) {
    expand[j].setAttribute('style', "visibility: visible");
  }
}
<!DOCTYPE html>
<html lang="en">
<head>
    <title>Essential JS 2 for TreeView </title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Essential JS 2 for TreeView UI Control">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-navigations/styles/material.css" rel="stylesheet">
    <script src="https://cdn.syncfusion.com/ej2/32.1.19/dist/ej2.min.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id="container">
        <div id="treeparent">
            <div id="tree"></div>
        </div>
    </div>
    
    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
    <style>
        #treeparent {
            display: block;
            max-width: 350px;
            max-height: 350px;
            margin: auto;
            overflow: auto;
            border: 1px solid #dddddd;
            border-radius: 3px;
        }
    </style>
</body>

</html>
#container {
  visibility: hidden;
}

#loader {
  color: #008cff;
  height: 40px;
  width: 30%;
  position: absolute;
  font-family: 'Helvetica Neue', 'calibiri';
  font-size: 14px;
  top: 45%;
  left: 45%;
}

Auto hide show expand collapse icon in React TreeView component

28 Feb 202516 minutes to read

You can display the expand icon by hovering the mouse over TreeView and hide the expand icon by leaving the mouse from TreeView. Refer to the following code sample to hide/show the expand/collapse icon automatically using the mouse.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
function App() {
    // Data source for TreeView component
    let countries = [
        { id: 1, name: 'India', hasChild: true },
        { id: 2, pid: 1, name: 'Assam' },
        { id: 3, pid: 1, name: 'Bihar' },
        { id: 4, pid: 1, name: 'Tamil Nadu' },
        { id: 6, pid: 1, name: 'Punjab' },
        { id: 7, name: 'Brazil', hasChild: true },
        { id: 8, pid: 7, name: 'Paraná' },
        { id: 9, pid: 7, name: 'Ceará' },
        { id: 10, pid: 7, name: 'Acre' },
        { id: 11, name: 'France', hasChild: true },
        { id: 12, pid: 11, name: 'Pays de la Loire' },
        { id: 13, pid: 11, name: 'Aquitaine' },
        { id: 14, pid: 11, name: 'Brittany' },
        { id: 15, pid: 11, name: 'Lorraine' },
        { id: 16, name: 'Australia', hasChild: true },
        { id: 17, pid: 16, name: 'New South Wales' },
        { id: 18, pid: 16, name: 'Victoria' },
        { id: 19, pid: 16, name: 'South Australia' },
        { id: 20, pid: 16, name: 'Western Australia' },
        { id: 21, name: 'China', hasChild: true },
        { id: 22, pid: 21, name: 'Guangzhou' },
        { id: 23, pid: 21, name: 'Shanghai' },
        { id: 24, pid: 21, name: 'Beijing' },
        { id: 25, pid: 21, name: 'Shantou' }
    ];
    let field = { dataSource: countries, id: 'id', text: 'name', parentID: 'pid', hasChildren: 'hasChild' };
    let treeObj;
    function onCreate() {
        let collapse = treeObj.element.querySelectorAll('.e-icons.e-icon-collapsible');
        let expand = treeObj.element.querySelectorAll('.e-icons.e-icon-expandable');
        hideIcon(expand, collapse);
        treeObj.element.addEventListener('mouseenter', (event) => {
            showIcon(expand, collapse);
        });
        treeObj.element.addEventListener('mouseleave', (event) => {
            hideIcon(expand, collapse);
        });
    }
    // hides expand/collapse icon on hovering the mouse
    function hideIcon(expand, collapse) {
        for (let i = 0; i < collapse.length; i++) {
            collapse[i].setAttribute('style', 'visibility: hidden');
        }
        for (let j = 0; j < expand.length; j++) {
            expand[j].setAttribute('style', 'visibility: hidden');
        }
    }
    // shows expand/collapse icon while leaving the mouse
    function showIcon(expand, collapse) {
        for (let i = 0; i < collapse.length; i++) {
            collapse[i].setAttribute('style', "visibility", "");
        }
        for (let j = 0; j < expand.length; j++) {
            expand[j].setAttribute('style', "visibility", "");
        }
    }
    return (<div className='control-pane'>
      <div className='control-section'>
      <div className='control_wrapper'>
          {/* Render TreeView */}
          <TreeViewComponent fields={field} ref={(treeview) => { treeObj = treeview; }} created={onCreate.bind(this)}/>
      </div>
      </div>
    </div>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('sample'));
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import {TreeViewComponent} from '@syncfusion/ej2-react-navigations';
import {enableRipple} from '@syncfusion/ej2-base';
enableRipple(true);

function App() {

   // Data source for TreeView component
  let countries: { [key: string]: Object }[]= [
         { id: 1, name: 'India', hasChild: true },
    { id: 2, pid: 1, name: 'Assam' },
    { id: 3, pid: 1, name: 'Bihar' },
    { id: 4, pid: 1, name: 'Tamil Nadu' },
    { id: 6, pid: 1, name: 'Punjab' },
    { id: 7, name: 'Brazil', hasChild: true },
    { id: 8, pid: 7, name: 'Paraná' },
    { id: 9, pid: 7, name: 'Ceará' },
    { id: 10, pid: 7, name: 'Acre' },
    { id: 11, name: 'France', hasChild: true },
    { id: 12, pid: 11, name: 'Pays de la Loire' },
    { id: 13, pid: 11, name: 'Aquitaine' },
    { id: 14, pid: 11, name: 'Brittany' },
    { id: 15, pid: 11, name: 'Lorraine' },
    { id: 16, name: 'Australia', hasChild: true },
    { id: 17, pid: 16, name: 'New South Wales' },
    { id: 18, pid: 16, name: 'Victoria' },
    { id: 19, pid: 16, name: 'South Australia' },
    { id: 20, pid: 16, name: 'Western Australia' },
    { id: 21, name: 'China', hasChild: true },
    { id: 22, pid: 21, name: 'Guangzhou' },
    { id: 23, pid: 21, name: 'Shanghai' },
    { id: 24, pid: 21, name: 'Beijing' },
    { id: 25, pid: 21, name: 'Shantou' }
    ];
    let field:Object ={ dataSource: countries, id: 'id', text: 'name', parentID: 'pid', hasChildren: 'hasChild' };
    let treeObj: TreeViewComponent;

     function onCreate(): void {
        let collapse: NodeListOf<Element> = treeObj.element.querySelectorAll('.e-icons.e-icon-collapsible');
        let expand: NodeListOf<Element> = treeObj.element.querySelectorAll('.e-icons.e-icon-expandable');
        hideIcon(expand, collapse);
        treeObj.element.addEventListener('mouseenter', (event:any) => {
          showIcon(expand, collapse);
        });
        treeObj.element.addEventListener('mouseleave', (event:any) => {
          hideIcon(expand, collapse);
        });
    }
    // hides expand/collapse icon on hovering the mouse
     function hideIcon(expand: any,collapse: any): void {
        for(let i: number = 0; i < collapse.length; i++ ){
          collapse[i].setAttribute('style','visibility: hidden');
        }
        for(let j: number = 0; j < expand.length; j++ ){
          expand[j].setAttribute('style','visibility: hidden');
        }
    }

  // shows expand/collapse icon while leaving the mouse
   function showIcon(expand: any, collapse: any): void {
      for(let i: number = 0; i < collapse.length; i++ ){
        collapse[i].setAttribute('style',"visibility", "");
      }
      for(let j: number = 0; j < expand.length; j++ ){
        expand[j].setAttribute('style',"visibility", "");
      }
  }
  return (
    <div className = 'control-pane'>
      <div className='control-section'>
      <div className='control_wrapper'>
          {/* Render TreeView */}
          <TreeViewComponent fields={field}  ref={(treeview) => { treeObj = treeview as TreeViewComponent; }} created={onCreate.bind(this)}/>
      </div>
      </div>
    </div>
  )
}
export default App;
ReactDOM.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React TreeView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="style.css" rel="stylesheet"/>
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-base/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-inputs/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-buttons/styles/material.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/32.1.19/ej2-react-navigations/styles/material.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
    <div id='treeparent'>
        <div id='sample'>
            <div id='loader'>Loading....</div>
        </div>
    </div>
</body>

</html>
#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

#treeparent {
    display: block;
    max-width: 350px;
    max-height: 350px;
    margin: auto;
    overflow: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
}

Auto hide show expand collapse icon in Angular TreeView component

27 Aug 20257 minutes to read

The TreeView component allows you to create a cleaner interface by automatically hiding expand/collapse icons and displaying them only when needed. You can show the expand/collapse icons when hovering over the TreeView and hide them when the mouse leaves the component area. This behavior is implemented using the created event to set up the necessary mouse event handlers and CSS styling.

Refer to the following code sample to hide/show the expand/collapse icon automatically using the mouse.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { TreeViewModule } from '@syncfusion/ej2-angular-navigations'
import { Component, Inject, ViewChild } from '@angular/core';
import { TreeViewComponent } from '@syncfusion/ej2-angular-navigations';
/**
 * TreeView Auto hide/show expand/collapse icons
 */
@Component({
  imports: [
    FormsModule, TreeViewModule
  ],
  standalone: true,
  selector: 'app-container',
  template: `<div id='treeparent'><ejs-treeview id='treeElement' #treevalidate [fields]='field' (created)='onCreate($event)'></ejs-treeview></div>`
})

export class AppComponent {
  // Data source for TreeView component
  public countries: Object[] = [
    { id: 1, name: 'India', hasChild: true },
    { id: 2, pid: 1, name: 'Assam' },
    { id: 3, pid: 1, name: 'Bihar' },
    { id: 4, pid: 1, name: 'Tamil Nadu' },
    { id: 6, pid: 1, name: 'Punjab' },
    { id: 7, name: 'Brazil', hasChild: true },
    { id: 8, pid: 7, name: 'ParanĂ¡' },
    { id: 9, pid: 7, name: 'CearĂ¡' },
    { id: 10, pid: 7, name: 'Acre' },
    { id: 11, name: 'France', hasChild: true },
    { id: 12, pid: 11, name: 'Pays de la Loire' },
    { id: 13, pid: 11, name: 'Aquitaine' },
    { id: 14, pid: 11, name: 'Brittany' },
    { id: 15, pid: 11, name: 'Lorraine' },
    { id: 16, name: 'Australia', hasChild: true },
    { id: 17, pid: 16, name: 'New South Wales' },
    { id: 18, pid: 16, name: 'Victoria' },
    { id: 19, pid: 16, name: 'South Australia' },
    { id: 20, pid: 16, name: 'Western Australia' },
    { id: 21, name: 'China', hasChild: true },
    { id: 22, pid: 21, name: 'Guangzhou' },
    { id: 23, pid: 21, name: 'Shanghai' },
    { id: 24, pid: 21, name: 'Beijing' },
    { id: 25, pid: 21, name: 'Shantou' }
  ];
  public field: Object = { dataSource: this.countries, id: 'id', text: 'name', parentID: 'pid', hasChildren: 'hasChild' };

  @ViewChild('treevalidate') tree?: TreeViewComponent;

  public onCreate(args: any): void {
    let collapse: NodeListOf<Element> = (this.tree as any)?.element.querySelectorAll('.e-icons.e-icon-collapsible') as NodeListOf<Element>;
    let expand: NodeListOf<Element> = (this.tree as any)?.element.querySelectorAll('.e-icons.e-icon-expandable') as NodeListOf<Element>;
    this.hideIcon(expand, collapse);
    (this.tree as any)?.element.addEventListener('mouseenter', (event: any) => {
      this.showIcon(expand, collapse);
    });
    (this.tree as any)?.element.addEventListener('mouseleave', (event: any) => {
      this.hideIcon(expand, collapse);
    });
  }
  // hides expand/collapse icon on hovering the mouse
  public hideIcon(expand: NodeListOf<Element>, collapse: NodeListOf<Element>) {
    for (let i: number = 0; i < collapse.length; i++) {
      collapse[i].setAttribute('style', 'visibility: hidden');
    }
    for (let j: number = 0; j < expand.length; j++) {
      expand[j].setAttribute('style', 'visibility: hidden');
    }
  }

  // shows expand/collapse icon while leaving the mouse
  public showIcon(expand: NodeListOf<Element>, collapse: NodeListOf<Element>) {
    for (let i: number = 0; i < collapse.length; i++) {
      collapse[i].setAttribute('style', "visibility");
    }
    for (let j: number = 0; j < expand.length; j++) {
      expand[j].setAttribute('style', "visibility");
    }
  }
}
@import 'node_modules/@syncfusion/ej2-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import 'node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material.css';
@import 'node_modules/@syncfusion/ej2-angular-navigations/styles/material.css';

#treeparent {
    display: block;
    max-width: 350px;
    max-height: 350px;
    margin: auto;
    overflow: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));